; --------------------------------
;
;  DJM Macros
;
; --------------------------------

; Sprite Macro
; input:
;	\1	xpos of destination
;	\2	ypos " "
;	\3	sprite ID number
;	Requires use of putspr subroutine

Spr	MACRO
	movem.l 	 d0-d2/a0-a2,-(a7)	;save registers for restoration later
	move.w	\1,d0
	move.w	\2,d1
	move.w	\3,d3
	bsr	putspr
	movem.l (a7)+,d0-d2/a0-a2  ;Restores registers to previous status
	ENDM

WriteStr	 MACRO
						move.w	\3,-(a7)
						pea 		\4(PC)
						move.w	\2,-(a7)
						move.w	\1,-(a7)
						jsr romlib[puttext]
						lea 		10(a7),a7
					 ENDM

WriteChar  MACRO
						move.w	#$00FF,-(a7)
						move.w	#$0000,-(a7)
						move.w	#$00FF,-(a7)
						move.w	\3,-(a7)
						move.w	\2,-(a7)
						move.w	\1,-(a7)
						move.w	\4,-(a7)
						jsr romlib[putchar]
						lea 		14(a7),a7
					 ENDM

SetFont 	 MACRO
						move.w	\1,-(a7)
						jsr romlib[set_font]
						lea 		2(a7),a7
					 ENDM

GetKeyStat MACRO
						move.w	#$FFFE,d0
						move.b	\1,d1
						rol.w 	d1,d0
						move.w	d0,($600018)
						nop
						nop
						nop
						nop
						move.b	($60001B),d0
					 ENDM
